<?php

require_once('Carte\CartePropriete.php');
class Plateau{

    
    protected $IA = [];
    private $players = [];
    private $cases = [];
    private $cartePropriete = [];
    private $carteChance = [];
    private $carteCommunaute =[];
    protected static $instance; // Contiendra l'instance de notre classe.
    private $nbDouble = 0;
    
    protected function __construct() { // Constructeur en privé.
    } 
        
        public static function getInstance()
        {
            if(!isset(self::$instance)) // Si on n'a pas encore instancié notre classe.
            {
                self::$instance = new self; // On s'instancie nous-mêmes. :)
            }
            
            return self::$instance;
        }

        // Lance les dés

        public function dés($db){

            // Gestion des variables de session

            $tour = $_SESSION['nbtour'] % 2;

            // Déroulement du jeu

            echo "C'est à ".$this->players[$tour]->getName()." de jouer !<br>";

            // Déplacement du joueur 

            $des1 = new Des('1');
            $des2 = new Des('2');
            $lance1 = $des1->laceup();
            $lance2 = $des2->laceup();
            $somme = $lance1 + $lance2;
            //$somme = $des1->laceup() + $des2->laceup();
            echo "Vous avancez de $somme cases.<br>";
            $this->players[$tour]->avancerJoueur($somme, $db);

            // La case sur laquelle il est tombé

            $position = $this->players[$tour]->getPosition();
            $case = $this->searchCase($position);
            $nomCase = $case->getName();
            echo "Vous arrivez sur la case : $nomCase<br>";
            $effetCase = $case->getEffet();
            echo "C'est une case : $effetCase<br>";

            // Action de la case

            $case->actionCase($this->players[$tour]->getID(), $this, $db);
                if($this->nbDouble != 3){
                    if($lance1 == $lance2){
                        $this->nbDouble += 1;
                        echo "<br>Vous avez fait ".$this->nbDouble." double ! Vous rejouez.<br><br>";
                        $this->dés($db);
                    }
                }
                else{
                    echo 'Vous avez fait 3 double vous allez en prison';
                }

        }

        public function achat(){

            $tour = $_SESSION['nbtour'] % 2;

            $argent = $this->players[$tour]->getArgent();
            if($argent >= 1500000){
                echo "Vous payez 1 500 000.<br>";
                $this->players[$tour]->débiter(1500000);
                echo "Félicitation vous devenez propriétaire !<br>";
                $idJoueur = $this->players[$tour]->getID();
                $position = $this->players[$tour]->getPosition();
                $carte = $this->searchCarte($position);
                $carte->setPossession($idJoueur);
            }

            else{
                echo "Vous n'avez pas assez d'argent.<br>";
            }                        
        }
        
        public function initCartes($db){
            for($i=1; $i<7; $i++){
                $cartePropriete[$i] = new CartePropriete($i, $db);
                $this->addCartePropriete($cartePropriete[$i]);
            }
           /* echo $this->getCartePropriete()[1]->getName();
            echo "<br><br>";*/
            for($i=1; $i<17; $i++){
                $carteChance[$i] = new CarteChance($i, $db);
                $this->addCarteChance($carteChance[$i]);
            }
           /* echo $this->getCarteChance()->getDescription();
            echo $this->getCarteChance()->getEffet();
            echo "<br><br>";*/
            for($i=1; $i<17; $i++){
                $carteCommunaute[$i] = new CarteCommunaute($i, $db);
                $this->addCarteCommunaute($carteCommunaute[$i]);
            }
          /*  echo $this->getCarteCommunaute()[8]->getDescription();
            echo $this->getCarteCommunaute()[8]->getEffet();*/
           

        }

        public function initCases($db){
            for($i=0; $i<40; $i++){
                $case[$i] = new Cases($i, $db);
                $this->addCase($case[$i]);
            }
            /*echo $this->getCases()[9]->getName();
            print_r($this->getCases());
            echo"<br><br>";*/
        }

        public function initJoueurs($db){
            $p1 = new Joueur(1,$db);
            //$p2 = new Joueur(2,$db);
            $this->addPlayer($p1);
            //$this->addPlayer($p2);
            print_r($this->getPlayers());
        }

        public function initGame($db){            

        }

        public function pushJoueursDb($db){
            foreach($this->getPlayers() as $player){
                $datas = $player->getData($db);
                print_r($datas);
                $sql = "UPDATE `joueur` SET `Position` = $datas[3], `Argent` = $datas[4] WHERE `ID` = $datas[0]";
                $db->sqlInsert($sql);
            }
        }

        public function pushCartesDb($db){
            foreach($this->getCartePropriete() as $cartePropriete){
                $datas = $cartePropriete->getData($db);
                $sql = "UPDATE `carte_propriete` SET `Possession` = '$datas[3]' WHERE `ID` = $datas[0]";
                $db->sqlInsert($sql);
            }
        }

        public function searchCarte($position){
            foreach($this->cartePropriete as $carte){
                if($carte->getPosition() == $position){
                    return $carte;
                }
            }
        }


        public function searchCase($position){
            foreach($this->cases as $case){
                if($case->getPosition() == $position){
                    return $case;
                }
            }       
        }

        public function startCreditPlayers($players){
            foreach ($players as $player) {
                $player->crediter(15000000);
                //echo $player->getSolde()."<br>";
            }
        }
        
        public function addPlayer($perso){
            $this->players[] = $perso;
        }
        
        public function addCase($case){
            $this->cases[] = $case;
        }
        
        public function addCartePropriete($cartePropriete){
            $this->cartePropriete[] = $cartePropriete;
        }
        public function addCarteChance($carteChance){
            $this->carteChance[]= $carteChance;
        }
        
        public function getCases(){
            return $this->cases;
        }
        
        public function getCartePropriete(){
            return $this->cartePropriete;
        }
		public function getCarteChance(){
		  return $this->carteChance;
		}
        public function addCarteCommunaute($CarteCommunaute){
            $this->carteCommunaute[] = $CarteCommunaute;
        }
        public function getCarteCommunaute(){
            return $this->carteCommunaute;
        }
        
        public function getPlayers(){
            return $this->players;
        }        
        function countPlayers($players){
            $nb=0;
            foreach ($players as $player) {
            $nb += 1;
            }
            return $nb;
        }

        function createIA($joueurs){ // compte les joueurs humains puis crée les IA manquantes.
            $nmb = $this->countPlayers($joueurs);
            if ($nmb < 4) {
                switch ($nmb) {
                    case 0:
                        echo "ajout de 4 IA<br>";
                        $p1 = new IA (1, "IA1", "Blue");
                        $this->IA[] = $p1;
                    case 1:
                        echo "ajout de 3 IA<br>";
                        $p2 = new IA (2, "IA2", "Red");
                        $this->IA[] = $p2;
                    case 2:
                        echo "ajout de 2 IA<br>";
                        $p3 = new IA (3, "IA3", "Green");
                        $this->IA[] = $p3;
                    case 3:
                        echo "ajout de 1 IA<br>";
                        $p4 = new IA (4, "IA4", "Purple");
                        $this->IA[] = $p4;
                        break;
                    default: "y a une couille";
                }
            }
            else echo "Le nombre maximum de joueurs est atteint, aucune IA ne sera crée";
            // PROBLEME return $this->IA;
        }


    }

?>